## dcm2niix 1.0.20161101

=== CMakeLists.txt ===
project(dcm2niix)
cmake_minimum_required(VERSION 2.6)

include(ucm.cmake)

# Option1: Choose whether to build the batch version
option(BATCH_VERSION "Build dcm2niibatch for multiple conversions as well" OFF)
message(${BATCH_VERSION})

# Option2: Choose whether to use static runtime
option(USE_STATIC_RUNTIME "Use static runtime" ON)
if(USE_STATIC_RUNTIME)
    ucm_set_runtime(STATIC)
else()
    ucm_set_runtime(DYNAMIC)
endif()

# Option3: Choose build type
set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bin")

#
# Zlib
#
#find_package(ZLIB)

# Predefined permission set to enforce proper permissions
# during install even if files in the sources have different
# settings
set(FILE_PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

##
## Sub-projects
##
add_subdirectory(console)

=== console/CMakeLists.txt ===
project(console)
set(PROGRAMS dcm2niix)

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    # using Clang
    add_definitions(-dead_strip)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # using GCC
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # using Intel C++
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    # using Visual Studio C++
endif ()


#We now use miniz, removing zlib dependency
#if(ZLIB_FOUND)
#  TARGET_LINK_LIBRARIES(dcm2niix z)
#else(ZLIB_FOUND)
#  ADD_DEFINITIONS(-DmyDisableZlib)
#endif(ZLIB_FOUND)
add_definitions(-DmyDisableJasper)
add_definitions(-DmyDisableOpenJPEG)

add_executable(dcm2niix
        main_console.cpp
        nii_dicom.cpp
        jpg_0XC3.cpp
        ujpeg.cpp
        nifti1_io_core.cpp
        nii_ortho.cpp
        nii_dicom_batch.cpp)


if (BATCH_VERSION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

    message("Creating batch version")

    # Resolve system dependency on yaml-cpp, which apparently does not
    # provide a CMake find_package() module.

    # Step 1: Search for library using pkg-config
    find_package(PkgConfig)
    if (PKG_CONFIG_FOUND)
        pkg_check_modules(YAML_CPP yaml-cpp)
        find_path(YAML_CPP_INCLUDE_DIR
                NAMES yaml-cpp
                PATHS ${YAML_CPP_INCLUDE_DIRS})
        find_library(YAML_CPP_LIBRARY
                NAMES yaml-cpp
                PATHS ${YAML_CPP_LIBRARY_DIRS})
    endif ()

    # Step 2: Search for library locally. Only searches for a folder called yaml-cpp
    if (NOT YAML_CPP_LIBRARY)
        message("Checking for yaml-cpp local folder: yaml-cpp")
        if (EXISTS ${CMAKE_SOURCE_DIR}/yaml-cpp)
            message("local version found")
            SET(YAML_CPP_BUILD_TOOLS OFF CACHE BOOL "Build test packages off")
            add_subdirectory(${CMAKE_SOURCE_DIR}/yaml-cpp ${CMAKE_SOURCE_DIR}/yaml-cpp)
            set(YAML_CPP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/yaml-cpp/include)
        else()
            message("Local version not found")
        endif()
    endif ()

    add_executable(dcm2niibatch
            main_console_batch.cpp
            nii_dicom.cpp
            jpg_0XC3.cpp
            ujpeg.cpp
            nifti1_io_core.cpp
            nii_ortho.cpp
            nii_dicom_batch.cpp)

    if (YAML_CPP_LIBRARY)
        target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARY})
    else()
        target_link_libraries(dcm2niibatch yaml-cpp)
    endif()


    if (YAML_CPP_INCLUDE_DIR)
        include_directories(${YAML_CPP_INCLUDE_DIR})
    endif ()
endif ()

install(TARGETS ${PROGRAMS} DESTINATION bin)

=== debian/changelog ===
dcm2niix (1.0.20161101-1) unstable; urgency=low

  * Initial release. (Closes: #843799)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 01 Dec 2016 18:42:22 +0000

=== debian/control ===
Source: dcm2niix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libyaml-cpp-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/dcm2niix.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBATCH_VERSION=ON -DUSE_STATIC_RUNTIME=OFF

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/dcm2niix-$1\.tar\.gz/ \
https://github.com/rordenlab/dcm2niix/tags .*/v(\d\S+)\.tar\.gz

## dcm2niix 1.0.20170130

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(dcm2niix)
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8)
 
 include(ucm.cmake)
 
@@ -35,3 +35,8 @@
 ## Sub-projects
 ##
 add_subdirectory(console)
+
+option(BUILD_DOCS "Build documentation (manpages)" OFF)
+if (BUILD_DOCS)
+    add_subdirectory(docs)
+endif ()

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+cmake_minimum_required(VERSION 2.8)
 project(console)
 set(PROGRAMS dcm2niix)
 
@@ -16,13 +17,6 @@
     # using Visual Studio C++
 endif ()
 
-
-#We now use miniz, removing zlib dependency
-#if(ZLIB_FOUND)
-#  TARGET_LINK_LIBRARIES(dcm2niix z)
-#else(ZLIB_FOUND)
-#  ADD_DEFINITIONS(-DmyDisableZlib)
-#endif(ZLIB_FOUND)
 add_definitions(-DmyDisableJasper)
 add_definitions(-DmyDisableOpenJPEG)
 
@@ -35,6 +29,22 @@
         nii_ortho.cpp
         nii_dicom_batch.cpp)
 
+option(USE_SYSTEM_ZLIB "Use the system zlib" OFF)
+if (USE_SYSTEM_ZLIB)
+  find_package(ZLIB REQUIRED)
+  add_definitions(-DmyDisableMiniZ)
+  target_include_directories(dcm2niix PRIVATE ${ZLIB_INCLUDE_DIRS})
+  target_link_libraries(dcm2niix ${ZLIB_LIBRARIES})
+endif ()
+
+option(USE_SYSTEM_TURBOJPEG "Use the system TurboJPEG" OFF)
+if (USE_SYSTEM_TURBOJPEG)
+  find_package(PkgConfig REQUIRED)
+  pkg_check_modules(TurboJPEG libturbojpeg)
+  add_definitions(-DmyTurboJPEG)
+  target_include_directories(dcm2niix PRIVATE ${TurboJPEG_INCLUDE_DIRS})
+  target_link_libraries(dcm2niix ${TurboJPEG_LIBRARIES})
+endif ()
 
 if (BATCH_VERSION)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
@@ -77,7 +87,10 @@
             nifti1_io_core.cpp
             nii_ortho.cpp
             nii_dicom_batch.cpp)
-
+	if(ZLIB_FOUND)
+		ADD_DEFINITIONS(-DmyDisableMiniZ)
+  		TARGET_LINK_LIBRARIES(dcm2niibatch z)
+	endif(ZLIB_FOUND)
     if (YAML_CPP_LIBRARY)
         target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARY})
     else()
@@ -88,6 +101,8 @@
     if (YAML_CPP_INCLUDE_DIR)
         include_directories(${YAML_CPP_INCLUDE_DIR})
     endif ()
+    
+    list(APPEND PROGRAMS dcm2niibatch)
 endif ()
 
 install(TARGETS ${PROGRAMS} DESTINATION bin)

=== debian/changelog ===
dcm2niix (1:1.0.20170130-2~nd15.04+1) vivid; urgency=medium

  * Backported for vivid.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 06 Apr 2017 17:47:55 -0400

dcm2niix (1:1.0.20170130-2) neurodebian; urgency=medium

  * debian/control
    - Updated Homepage to point to github repo
  * debian/rules
    - enable building dcm2niixbatch. Also added libyaml-cpp-dev bdependency
      (and libboost-dev which it needs but not installs on older 
      debian/ubuntus)

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 06 Apr 2017 14:31:56 -0400

dcm2niix (1:1.0.20170130-1) neurodebian; urgency=medium

  * Introduced 1: epoch version prefix to conform to current upstream
    version format
  * Fresh release should resolve issues with json output

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 30 Jan 2017 12:48:10 -0500

dcm2niix (20161101+git66-g672f4d2-1) neurodebian; urgency=medium

  * New upstream snapshot -- various bug fixes (handling of non-existing
    output directory, json output, etc)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 16 Jan 2017 12:45:53 -0500

dcm2niix (20160921+git16-g0339407-1) neurodebian; urgency=medium

  * New upstream snapshot from 20160921-16-g0339407
    - now will fail if output directory is N/A
    - various minor fixups

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 04 Oct 2016 10:15:54 -0400

dcm2niix (20160921-1) neurodebian; urgency=medium

  * Fresh upstream release
    + Support 3D lossless JPEG saved as multiple fragments
  * Switching to upstream versioning scheme (by release date)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 23 Sep 2016 08:17:42 -0400

dcm2niix (0.20160606.1+git51-g615d612-1) neurodebian; urgency=medium

  * Fresh upstream snapshot which addresses the concern of use of
    non-initialized fields in the NIfTI headers See
    https://github.com/neurolabusc/dcm2niix/issues/45 for more info

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 19 Sep 2016 10:29:01 -0400

dcm2niix (0.20160606.1+git22-gf6471c0-1) neurodebian; urgency=medium

  * New upstream snapshot (not officially "released")

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 29 Jul 2016 16:14:11 -0400

dcm2niix (0.20160606.1+git1-gf6ba376-1) neurodebian; urgency=medium

  * New upstream snapshot from 20160606-1-gf6ba376 with BIDS support

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 09 Jun 2016 10:43:01 -0400

dcm2niix (0.20150909.1+git1-g8914c07-1) neurodebian; urgency=medium

  * Initial release.

 -- Michael Hanke <mih@debian.org>  Sun, 27 Sep 2015 10:23:35 +0200

=== debian/control ===
Source: dcm2niix
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9~),
               cmake,
               zlib1g-dev,
               libyaml-cpp-dev, libboost-dev,
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/dcm2niix.git
Vcs-Git: git://anonscm.debian.org/pkg-exppsy/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends},
         ${misc:Depends}
Description: converts DICOM and PAR/REC files into the NIfTI format
 This is the successor of the well-known dcm2nii program. it aims to provide
 same functionality albeit with much faster operation.
 This is a new tool that is not yet well tested, and does not handle ancient
 proprietary formats. Use with care.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

# this figures out the last merge point from 'master' into the Debian branch and
# then described this commit relative to the last release tag (release/...)
# If this should make any sense the local upstream branch must track upstream's
# master or whatever other source branch.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'release/[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^release/,,' -e 's/-/+git/')

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBATCH_VERSION=ON

override_dh_clean:
	dh_clean
	# remove stuff we don't carry in the upstream tarball
	rm -rf dcm2laz qtGui wxWidgets xcode *.command console/unused

dfsg-source-tree:
	# at this point we are golden

# make orig tarball from repository content
get-orig-source: dfsg-source-tree
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz

## dcm2niix 1.0.20170403

=== console/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(console)

# Option Choose whether to use static runtime
include(ucm.cmake)
option(USE_STATIC_RUNTIME "Use static runtime" ON)
if(USE_STATIC_RUNTIME)
    ucm_set_runtime(STATIC)
else()
    ucm_set_runtime(DYNAMIC)
endif()

set(PROGRAMS dcm2niix)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    # using Clang
    add_definitions(-Wno-deprecated-register)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # using GCC
    add_definitions(-Wno-unused-result)
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # using Intel C++
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    # using Visual Studio C++
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018")   # '<': signed/unsigned mismatch
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4068")   # unknown pragma
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4101")   # unreferenced local variable
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244")   # 'initializing': conversion from 'double' to 'int', possible loss of data
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267")   # 'initializing': conversion from 'size_t' to 'int', possible loss of data
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4305")   # 'argument': truncation from 'double' to 'float'
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4308")   # negative integral constant converted to unsigned type
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4334")   # '<<': result of 32-bit shift implicitly converted to 64 bits
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")   # 'uint32_t' : forcing value to bool 'true' or 'false'
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")   # The file contains a character that cannot be represented in the current code page
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")   # 'access': The POSIX name for this item is deprecated
endif()

add_executable(dcm2niix
    main_console.cpp
    nii_dicom.cpp
    jpg_0XC3.cpp
    ujpeg.cpp
    nifti1_io_core.cpp
    nii_ortho.cpp
    nii_dicom_batch.cpp)

option(USE_SYSTEM_ZLIB "Use the system zlib" OFF)
if(USE_SYSTEM_ZLIB)
    find_package(ZLIB REQUIRED)
    add_definitions(-DmyDisableMiniZ)
    target_include_directories(dcm2niix PRIVATE ${ZLIB_INCLUDE_DIRS})
    target_link_libraries(dcm2niix ${ZLIB_LIBRARIES})
endif()

option(USE_SYSTEM_TURBOJPEG "Use the system TurboJPEG" OFF)
if(USE_SYSTEM_TURBOJPEG)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(TurboJPEG libturbojpeg)
    add_definitions(-DmyTurboJPEG)
    target_include_directories(dcm2niix PRIVATE ${TurboJPEG_INCLUDE_DIRS})
    target_link_libraries(dcm2niix ${TurboJPEG_LIBRARIES})
endif()

option(USE_JASPER "Compile with Jasper support" OFF)
if(USE_JASPER)
    find_package(Jasper REQUIRED)
    add_definitions(-DmyEnableJasper)
    target_include_directories(dcm2niix PRIVATE ${JASPER_INCLUDE_DIR})
    target_link_libraries(dcm2niix ${JASPER_LIBRARIES})
else ()
    add_definitions(-DmyDisableJASPER)
endif()

option(USE_OPENJPEG "Build with OpenJPEG support" OFF)
if(USE_OPENJPEG)
    option(OpenJPEG_DIR "Path to OpenJPEG configuration file" "")

    find_package(OpenJPEG)
    target_include_directories(dcm2niix PRIVATE ${OPENJPEG_INCLUDE_DIRS})
    target_link_libraries(dcm2niix ${OPENJPEG_LIBRARIES})
else ()
    add_definitions(-DmyDisableOpenJPEG)
endif()

option(BATCH_VERSION "Build dcm2niibatch for multiple conversions" OFF)
if(BATCH_VERSION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

    add_executable(dcm2niibatch
        main_console_batch.cpp
        nii_dicom.cpp
        jpg_0XC3.cpp
        ujpeg.cpp
        nifti1_io_core.cpp
        nii_ortho.cpp
        nii_dicom_batch.cpp)

    option(YAML-CPP_DIR "Path to yaml-cpp configuration file" "")

    find_package(YAML-CPP)
    target_include_directories(dcm2niibatch PRIVATE ${YAML_CPP_INCLUDE_DIR})
    target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARIES})

    if(ZLIB_FOUND)
        add_definitions(-DmyDisableMiniZ)
        target_link_libraries(dcm2niibatch z)
    endif()

    if(JASPER_FOUND)
        target_link_libraries(dcm2niibatch ${JASPER_LIBRARIES})
    else()
        add_definitions(-DmyDisableJASPER)
    endif()

    if(USE_OPENJPEG)
        target_include_directories(dcm2niibatch PRIVATE ${OPENJPEG_INCLUDE_DIRS})
        target_link_libraries(dcm2niibatch ${OPENJPEG_LIBRARIES})
    else()
        add_definitions(-DmyDisableOpenJPEG)
    endif()

    list(APPEND PROGRAMS dcm2niibatch)
endif()

install(TARGETS ${PROGRAMS} DESTINATION ${CMAKE_INSTALL_PREFIX})

=== debian/changelog ===
dcm2niix (1:1.0.20170403-1~nd15.10+1) wily; urgency=medium

  * Backported for wily.
  * Applied additional patch from debian/patches/wily-dsc-patch.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 24 Apr 2017 14:10:43 -0400

dcm2niix (1:1.0.20170403-1) neurodebian; urgency=medium

  * New upstream release.
  * Build against TurboJPEG.

 -- Michael Hanke <mih@debian.org>  Tue, 18 Apr 2017 09:10:34 +0200

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,11 @@
 Priority: optional
 Build-Depends: debhelper (>= 9~),
                cmake,
+               pkg-config,
+               libboost-dev,
+               libyaml-cpp-dev,
                zlib1g-dev,
-               libyaml-cpp-dev, libboost-dev,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/dcm2niix.git
 Vcs-Git: git://anonscm.debian.org/pkg-exppsy/dcm2niix.git
 Homepage: https://github.com/rordenlab/dcm2niix

=== debian/rules ===
--- 
+++ 
@@ -9,15 +9,20 @@
 # then described this commit relative to the last release tag (release/...)
 # If this should make any sense the local upstream branch must track upstream's
 # master or whatever other source branch.
-gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'release/[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^release/,,' -e 's/-/+git/')
+gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'v[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^v,,' -e 's/-/+git/')
+
+export DH_VERBOSE = 1
 
 # one ring to rule them all ...
 %:
-	dh $@ --buildsystem=cmake
+	dh $@ --buildsystem=cmake --builddirectory=build
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DBATCH_VERSION=ON
+	  -DUSE_STATIC_RUNTIME:BOOL=OFF \
+	  -DUSE_SYSTEM_TURBOJPEG:BOOL=OFF \
+	  -DUSE_SYSTEM_ZLIB:BOOL=ON \
+	  -DBATCH_VERSION:BOOL=ON
 
 override_dh_clean:
 	dh_clean
@@ -32,3 +37,10 @@
 	# orig tarball, turn directory into something nicer
 	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
 		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz
+
+# check that DSC patches still apply
+maint-check-dsc-patches:
+	@for p in debian/patches/*-dsc-patch; \
+		do echo "check $$p"; \
+		patch -p1 --dry-run < $$p || exit 1 ; \
+	done

## dcm2niix 1.0.20170923

=== debian/changelog ===
dcm2niix (1.0.20170923-1) unstable; urgency=medium

  * New upstream version 1.0.20170923
  * Bump the standards version to 4.1.1

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 09 Oct 2017 18:45:04 +0100

dcm2niix (1.0.20170818-1) unstable; urgency=medium

  * New upstream version 1.0.20170818
  * Add pigz to Suggests
  * Bump standards version to 4.1.0

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 23 Aug 2017 19:35:10 +0100

dcm2niix (1.0.20170724-1) unstable; urgency=medium

  * Upgrade watch file to version 4
  * New upstream version 1.0.20170724
  * Bump standards version to 4.0.1, no changes required
  * Add missing get-orig-source target
  * Build with JPEG support using TurboJPEG

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 12 Aug 2017 19:03:13 +0100

dcm2niix (1.0.20170624-1) unstable; urgency=medium

  * New upstream version 1.0.20170624
  * Bump standards version to 4.0.0, no changes required

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 13 Jul 2017 19:03:13 +0100

dcm2niix (1.0.20170528-1) experimental; urgency=medium

  * New upstream version 1.0.20170528

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 03 Jun 2017 09:06:53 +0100

dcm2niix (1.0.20170429-1) experimental; urgency=medium

  * New upstream version 1.0.20170429
  * Update copyright information
  * Drop the patch queue, no longer required
  * Specify the source directory and build system
  * Use the system zlib and openjpeg2 libraries
  * Build and install the manpages with Sphinx

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 11 May 2017 18:46:40 +0100

=== debian/control ===
Source: dcm2niix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libopenjp2-7-dev,
               libturbojpeg0-dev,
               libyaml-cpp-dev,
               pkg-config,
               python3-sphinx,
               zlib1g-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/dcm2niix.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: pigz
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --sourcedirectory=console --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -rf build/man

override_dh_auto_configure:
	dh_auto_configure -- -DBATCH_VERSION=ON \
		-DUSE_STATIC_RUNTIME=OFF \
		-DUSE_SYSTEM_ZLIB=ON \
		-DUSE_OPENJPEG=ON \
		-DUSE_TURBOJPEG=ON

override_dh_auto_build:
	dh_auto_build
	sphinx-build -N -b man docs/source build/man

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

## dcm2niix 1.0.20171017+git3-g9ccc4c0

=== debian/changelog ===
dcm2niix (1:1.0.20171017+git3-g9ccc4c0-1~nd17.04+1) zesty; urgency=medium

  * Backported for zesty.
  * Applied additional patch from debian/patches/zesty-dsc-patch.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 03 Nov 2017 12:54:32 -0400

dcm2niix (1:1.0.20171017+git3-g9ccc4c0-1) neurodebian; urgency=medium

  * Fresh upstream snapshot
    - should bettersupport exporting sidecar information in multiband
      sequences

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 03 Nov 2017 11:06:24 -0400

dcm2niix (1:1.0.20170923+git2-gb68d409-1) neurodebian; urgency=medium

  * New upstream release with post release fixes/workarounds

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 28 Sep 2017 16:28:48 -0400

dcm2niix (1:1.0.20170818+git8-gdd1d994-1) neurodebian; urgency=medium

  * New upstream snapshot from v1.0.20170818-8-gdd1d994
  * debian/patches/jessie-dsc-patch adjusted and linked to be applied on zesty
    as well

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 30 Aug 2017 11:11:00 -0400

dcm2niix (1:1.0.20170724+git3-gab68e44-1) neurodebian; urgency=medium

  * Fresh post-release snapshot
    - all errors go now to stderr instead of stdout

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 08 Aug 2017 11:54:31 -0400

dcm2niix (1:1.0.20170624+git8-g87d2142-1) neurodebian; urgency=medium

  * New upstream snapshot from v1.0.20170624-8-g87d2142
  * Build with -DUSE_OPENJPEG=ON so that it passes qa tests
    - added libopenjp2-7-dev to Build-Depends

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 24 Jul 2017 10:11:02 -0400

dcm2niix (1:1.0.20170624-1) neurodebian; urgency=medium

  * Minor bugfix release

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 24 Jun 2017 16:32:13 -0700

dcm2niix (1:1.0.20170623-1) neurodebian; urgency=medium

  * Fixes up issue with SliceTiming not being reported

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 23 Jun 2017 10:33:06 -0700

dcm2niix (1:1.0.20170621-1) neurodebian; urgency=medium

  * New upstream release
    - better sanitarization of Dates in the json side-cars
    - estimation of "TotalReadoutTime" etc

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 23 Jun 2017 09:57:01 -0400

=== debian/control ===
Source: dcm2niix
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9~),
               cmake,
               pkg-config,
               libboost-dev,
               libopenjp2-7-dev,
               libyaml-cpp-dev,
               zlib1g-dev,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/dcm2niix.git
Vcs-Git: git://anonscm.debian.org/pkg-exppsy/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends},
         ${misc:Depends}
Description: converts DICOM and PAR/REC files into the NIfTI format
 This is the successor of the well-known dcm2nii program. it aims to provide
 same functionality albeit with much faster operation.
 This is a new tool that is not yet well tested, and does not handle ancient
 proprietary formats. Use with care.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

# this figures out the last merge point from 'master' into the Debian branch and
# then described this commit relative to the last release tag (release/...)
# If this should make any sense the local upstream branch must track upstream's
# master or whatever other source branch.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'v[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^v,,' -e 's/-/+git/')

export DH_VERBOSE = 1

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DUSE_STATIC_RUNTIME:BOOL=OFF \
	  -DUSE_SYSTEM_TURBOJPEG:BOOL=OFF \
      -DUSE_OPENJPEG:BOOL=ON \
	  -DUSE_SYSTEM_ZLIB:BOOL=ON \
	  -DBATCH_VERSION:BOOL=ON

override_dh_clean:
	dh_clean
	# remove stuff we don't carry in the upstream tarball
	rm -rf dcm2laz qtGui wxWidgets xcode *.command console/unused

dfsg-source-tree:
	# at this point we are golden

# make orig tarball from repository content
get-orig-source: dfsg-source-tree
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz

# check that DSC patches still apply
maint-check-dsc-patches:
	@for p in debian/patches/*-dsc-patch; \
		do echo "check $$p"; \
		patch -p1 --dry-run < $$p || exit 1 ; \
	done

## dcm2niix 1.0.20171215

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
endif()

project(dcm2niix)

include(${CMAKE_SOURCE_DIR}/SuperBuild/SuperBuild.cmake)

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -11,15 +11,26 @@
     ucm_set_runtime(DYNAMIC)
 endif()
 
+# Basic CMake build settings
+set(CMAKE_BUILD_TYPE "Release" CACHE STRING
+    "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
+set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS  "Debug;Release;RelWithDebInfo;MinSizeRel")
+
 set(PROGRAMS dcm2niix)
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     # using Clang
     add_definitions(-Wno-deprecated-register)
+    add_definitions(-fno-caret-diagnostics)
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
     # using GCC
-    add_definitions(-Wno-unused-result)
+    if (${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER 4.4.7)
+        add_definitions(-Wno-unused-result)    # available since GCC 4.5
+    endif()
+    if (${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER 4.7.4)
+        add_definitions(-fno-diagnostics-show-caret)    # available since GCC 4.8
+    endif()
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
     # using Intel C++
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
@@ -44,6 +55,7 @@
     jpg_0XC3.cpp
     ujpeg.cpp
     nifti1_io_core.cpp
+    nii_foreign.cpp
     nii_ortho.cpp
     nii_dicom_batch.cpp)
 
@@ -55,30 +67,37 @@
     target_link_libraries(dcm2niix ${ZLIB_LIBRARIES})
 endif()
 
-option(USE_SYSTEM_TURBOJPEG "Use the system TurboJPEG" OFF)
-if(USE_SYSTEM_TURBOJPEG)
+option(USE_TURBOJPEG "Use TurboJPEG to decode classic JPEG" OFF)
+if(USE_TURBOJPEG)
     find_package(PkgConfig REQUIRED)
-    pkg_check_modules(TurboJPEG libturbojpeg)
+    pkg_check_modules(TURBOJPEG REQUIRED libturbojpeg)
     add_definitions(-DmyTurboJPEG)
-    target_include_directories(dcm2niix PRIVATE ${TurboJPEG_INCLUDE_DIRS})
-    target_link_libraries(dcm2niix ${TurboJPEG_LIBRARIES})
+    target_include_directories(dcm2niix PRIVATE ${TURBOJPEG_INCLUDEDIR})
+    target_link_libraries(dcm2niix ${TURBOJPEG_LIBRARIES})
 endif()
 
-option(USE_JASPER "Compile with Jasper support" OFF)
+option(USE_JASPER "Build with JPEG2000 support using Jasper" OFF)
 if(USE_JASPER)
     find_package(Jasper REQUIRED)
     add_definitions(-DmyEnableJasper)
     target_include_directories(dcm2niix PRIVATE ${JASPER_INCLUDE_DIR})
     target_link_libraries(dcm2niix ${JASPER_LIBRARIES})
-else ()
-    add_definitions(-DmyDisableJASPER)
 endif()
 
-option(USE_OPENJPEG "Build with OpenJPEG support" OFF)
+option(USE_OPENJPEG "Build with JPEG2000 support using OpenJPEG" OFF)
 if(USE_OPENJPEG)
-    option(OpenJPEG_DIR "Path to OpenJPEG configuration file" "")
+    set(OpenJPEG_DIR "${OpenJPEG_DIR}${OPENJPEG_DIR}" CACHE PATH "Path to yaml-cpp configuration file" FORCE)
 
-    find_package(OpenJPEG)
+    find_package(OpenJPEG REQUIRED)
+
+    if(WIN32)
+        if(BUILD_SHARED_LIBS)
+            add_definitions(-DOPJ_EXPORTS)
+        else()
+            add_definitions(-DOPJ_STATIC)
+        endif()
+    endif()
+
     target_include_directories(dcm2niix PRIVATE ${OPENJPEG_INCLUDE_DIRS})
     target_link_libraries(dcm2niix ${OPENJPEG_LIBRARIES})
 else ()
@@ -95,27 +114,35 @@
         jpg_0XC3.cpp
         ujpeg.cpp
         nifti1_io_core.cpp
+        nii_foreign.cpp
         nii_ortho.cpp
         nii_dicom_batch.cpp)
 
-    option(YAML-CPP_DIR "Path to yaml-cpp configuration file" "")
+    set(YAML-CPP_DIR ${YAML-CPP_DIR} CACHE PATH "Path to yaml-cpp configuration file" FORCE)
 
-    find_package(YAML-CPP)
+    find_package(YAML-CPP REQUIRED)
     target_include_directories(dcm2niibatch PRIVATE ${YAML_CPP_INCLUDE_DIR})
     target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARIES})
 
     if(ZLIB_FOUND)
         add_definitions(-DmyDisableMiniZ)
+        target_include_directories(dcm2niibatch PRIVATE ${ZLIB_INCLUDE_DIRS})
         target_link_libraries(dcm2niibatch z)
     endif()
 
-    if(JASPER_FOUND)
-        target_link_libraries(dcm2niibatch ${JASPER_LIBRARIES})
-    else()
-        add_definitions(-DmyDisableJASPER)
+    if(TURBOJPEG_FOUND)
+        add_definitions(-DmyTurboJPEG)
+        target_include_directories(dcm2niibatch PRIVATE ${TURBOJPEG_INCLUDEDIR})
+        target_link_libraries(dcm2niibatch ${TURBOJPEG_LIBRARIES})
     endif()
 
-    if(USE_OPENJPEG)
+    if(JASPER_FOUND)
+        add_definitions(-DmyEnableJasper)
+        target_include_directories(dcm2niibatch PRIVATE ${JASPER_INCLUDE_DIR})
+        target_link_libraries(dcm2niibatch ${JASPER_LIBRARIES})
+    endif()
+
+    if(OPENJPEG_FOUND)
         target_include_directories(dcm2niibatch PRIVATE ${OPENJPEG_INCLUDE_DIRS})
         target_link_libraries(dcm2niibatch ${OPENJPEG_LIBRARIES})
     else()
@@ -125,4 +152,4 @@
     list(APPEND PROGRAMS dcm2niibatch)
 endif()
 
-install(TARGETS ${PROGRAMS} DESTINATION ${CMAKE_INSTALL_PREFIX})
+install(TARGETS ${PROGRAMS} DESTINATION bin)

=== debian/changelog ===
dcm2niix (1.0.20171215-1) unstable; urgency=medium

  * Ensure tags are signed
  * New upstream version 1.0.20171215
  * Bump the debhelper version to 11
  * Bump the standards version to 4.1.3
  * Drop get-orig-source target, use uscan instead

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 04 Feb 2018 14:21:38 +0000

dcm2niix (1.0.20171017-1) unstable; urgency=medium

  * New upstream version 1.0.20171017
  * Install the upstream change log

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 21 Oct 2017 22:44:36 +0100

=== debian/control ===
Source: dcm2niix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11),
               libopenjp2-7-dev,
               libturbojpeg0-dev,
               libyaml-cpp-dev,
               pkg-config,
               python3-sphinx,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/dcm2niix.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: pigz
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

## dcm2niix 1.0.20180622

=== debian/changelog ===
dcm2niix (1.0.20180622-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 18 Sep 2018 14:33:27 +0200

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
                pkg-config,
                python3-sphinx,
                zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/dcm2niix.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/dcm2niix.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/med-team/dcm2niix
+Vcs-Git: https://salsa.debian.org/med-team/dcm2niix.git
 Homepage: https://github.com/rordenlab/dcm2niix
 
 Package: dcm2niix
